# DVD Empire video scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 1")
    vw.setAspectRatio("Standard 1.33:1")
    vw.setSubtitled("False")
    vw.setLanguage("English")
    vw.setCertification("NR")
    vw.setCurrencySymbol("$")


    i = string.find(source, "</strong> Matches Found")

    if i != -1:
        source = searchForPlus(source, "</strong> Matches Found")
        source = searchForPlus(source, ">&nbsp;1.")
        source = searchForPlus(source, "href='")
        i = string.find(source, "'")
        url = "http://www.dvdempire.com" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()

    # Find Title
    i = string.find(source, "<td class=\"fontxlarge\"")

    if i == -1:
        return

    source = searchForPlus(source, "<td class=\"fontxlarge\"")
    source = searchForPlus(source, "<strong>")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    vw.setTitle(title)


    # Find Format
    i = string.find(source, "<nobr>")

    if i != -1:
        format = searchForPlus(source, "<nobr>")
        format = searchForPlus(format, "'>")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        vw.setFormat(format)


    # Find Image
    i = string.find(source, "&tab=5#topoftabs")

    if (i != -1):
        images = searchForPlus(source, "&tab=5#topoftabs")
        images = searchForPlus(images, " src='")
        i = string.find(images, "'")
        image = stripText(images[0:i])

        i = string.find(image, "dvd-no-image.gif")

        if i == -1:
            vw.setImage1(image)

    i = string.find(source, ">Front<")

    if i != -1:
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        url = stripText(source[i-200:])
        url = searchForPlus(url, "href='")
        i = string.find(url, "'")
        url = "http://www.dvdempire.com" + stripText(url[0:i])
        url = string.replace(url, "&amp;", "&")
        images = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(images)
        t2.close()

        i = string.find(images, "Click to view")

        if i != -1:
            images = searchForPlus(images, "Click to view")
            images = searchForPlus(images, " src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])
            vw.setLargeImage1(image)

        i = string.find(source, ">Back<")

        if i != -1:
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            url = stripText(source[i-200:])
            url = searchForPlus(url, "href='")
            i = string.find(url, "'")
            url = "http://www.dvdempire.com" + stripText(url[0:i])
            url = string.replace(url, "&amp;", "&")
            images = http.getContents(url)
            t2 = open(vw.getLogsDir() + "trace3.html", "w")
            t2.write(images)
            t2.close()

            i = string.find(images, "Click to view")

            if i != -1:
                images = searchForPlus(images, "Click to view")
                images = searchForPlus(images, " src=\"")
                i = string.find(images, "\"")
                image = stripText(images[0:i])
                vw.setLargeImage2(image)


    # Find Price
    i = string.find(source, ">$")

    if i != -1 and i < 2500:
        source = source[i+1:]
        i = string.find(source, "<")
        value = stripText(source[0:i])
        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Comments
    comments = ""
    i = string.find(source, ">Synopsis<")

    if i != -1:
        comment = searchForPlus(source, ">Synopsis<")
        comment = searchForPlus(comment, "class=")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</td>")
        comments = stripText(comment[0:i])
        comments = string.replace(comments, ">i<", "> <")


    # Find Comments part 2
    i = string.find(source, ">Features:<")

    if (i != -1):
        comment = searchForPlus(source, ">Features:<")
        comment = searchForPlus(comment, "class=")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</td>")
        comment = "Features:<br/>" + stripText(comment[0:i])
        comments = appendComment(comments, comment)

    vw.setProductInfo(comments)


    # Find Actors
    actorTag = ">Actors:"
    i = string.find(source, actorTag)

    if i != -1:
        source = searchForPlus(source, actorTag)
        i = string.find(source, "</td>")
        actors = stripText(source[0:i])

        while (searchFor(actors, "\">") != None):
            actors = searchForPlus(actors, "\">")
            i = string.find(actors, "</a>")
            actor = stripText(actors[0:i])
            vw.setActor(stripText(actor))


    # Find Director
    i = string.find(source, ">Directors:")

    if i != -1:
        director = ""
        directors = searchForPlus(source, ">Directors:")
        i = string.find(directors, "</td>")
        directors = stripText(directors[0:i])

        i = string.find(directors, "<br /><br />")

        if i != -1:
            directors = stripText(directors[0:i])

        while (searchFor(directors, "\">") != None):
            directors = searchForPlus(directors, "\">")
            i = string.find(directors, "</a>")
            temp = stripText(directors[0:i])
            vw.setDirector(temp)


    # Find Writer
    i = string.find(source, ">Writers:")

    if i != -1:
        screenwriter = ""
        screenwriters = searchForPlus(source, ">Writers:")
        i = string.find(screenwriters, "</td>")
        screenwriters = stripText(screenwriters[0:i])

        i = string.find(screenwriters, "<br /><br />")

        if i != -1:
            screenwriters = stripText(screenwriters[0:i])


        while (searchFor(screenwriters, "\">") != None):
            screenwriters = searchForPlus(screenwriters, "\">")
            i = string.find(screenwriters, "</a>")
            temp = stripText(screenwriters[0:i])
            vw.setScreenwriter(temp)


    # Find Widescreen, color
    i = string.find(source, ">Video:")

    if i != -1:
        video = searchForPlus(source, ">Video:")
        video = searchForPlus(video, "<tr>")
        i = string.find(video, "</tr>")
        video = stripText(video[0:i])

        i = string.find(video, "Anamorphic")

        if i != -1:
            vw.setAnamorphic("true")

        i = string.find(video, "Widescreen ")

        if i != -1:
            wide = searchForPlus(video, "Widescreen ")
            i = string.find(wide, " ")

            if i != -1:
                vw.setAspectRatio("Widescreen " + stripText(wide[0:i]))
            else:
                vw.setAspectRatio("Widescreen " + stripText(wide))

        i = string.find(video, "Color")

        if i != -1:
            vw.setColor("Color")

        i = string.find(video, "B&W")

        if i != -1:
            vw.setColor("B&W")


    # Find Sound
    i = string.find(source, ">Audio:<")

    if i != -1:
        sound = searchForPlus(source, ">Audio:<")
        sound = searchForPlus(sound, ": ")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])
        i = string.find(sound, "[CC]")

        if i != -1:
            sound = stripText(sound[0:i])
            vw.setClosedCaptioned("true")

        vw.setSound(sound)


    # Find Release date
    i = string.find(source, ">Release Date:")

    if i != -1:
        date = searchForPlus(source, ">Release Date:")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)


    # Find UPC
    i = string.find(source, ">UPC Code:")

    if i != -1:
        upc = searchForPlus(source, ">UPC Code:")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        vw.setUPC(upc)


    # Find Studio
    i = string.find(source, ">Studio:<")

    if i != -1:
        studio = searchForPlus(source, ">Studio:<")
        studio = searchForPlus(studio, "'>")
        i = string.find(studio, "<li>")
        studio = stripText(studio[0:i])
        i = string.find(studio, "<")

        if i != -1:
            studio = stripText(studio[0:i])

        vw.setStudio(studio)


    # Find Copyright date
    i = string.find(source, ">Production Year:")

    if i != -1:
        copyDate = searchForPlus(source, ">Production Year:")
        copyDate = searchForPlus(copyDate, ">")
        i = string.find(copyDate, "<")
        copyDate = stripText(copyDate[0:i])
        vw.setCopyrightDate(copyDate)


    # Find Running time
    i = string.find(source, ">Length:")

    if i != -1:
        running = searchForPlus(source, ">Length:")
        running = searchForPlus(running, ">")
        i = string.find(running, "<")
        running = stripText(running[0:i])
        vw.setRunningTime(running)


    # Find Rating
    i = string.find(source, ">Rating:")

    if i != -1:
        mpaa = searchForPlus(source, ">Rating:")
        mpaa = searchForPlus(mpaa, ">")
        i = string.find(mpaa, "<")
        mpaa = stripText(mpaa[0:i])

        if mpaa != "NR":
            mpaa = mpaa + " (MPAA)"

        vw.setCertification(mpaa)


    # Find Category
    i = string.find(source, ">Category<")

    if i != -1:
        category = searchForPlus(source, ">Category<")
        category = searchForPlus(category, "\">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        vw.setCategory1(category)


    # Find Series
    i = string.find(source, ">Series<")

    if i != -1:
        series = searchForPlus(source, ">Series<")
        series = searchForPlus(series, "\">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        vw.setSeries(series)



try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
